/////////////////////////USE IN PC BROWSER///////////////////////////////
//var urlHeadAjax = "http://bigbang.8800.org:6767/json-rpc";
//Mifi接口调用地址头
var urlHeadAjax = null;
//广告接口调用地址头
var adUrlHead = "http://172.28.1.215:7080/base/rest";
var statUrlHead = "http://172.28.1.215:7080/base/rest";

function getUrlHeadAjax(){
	var rst;
	if (urlHeadAjax){
		rst = urlHeadAjax;
	} else {
		var hostip = getMifiString("hostip");
		if (hostip == "" || hostip == null)
			hostip = "172.28.1.215:7080";
		
		urlHeadAjax = "http://" + hostip + "/base/rest";
		rst = urlHeadAjax;
	}
	
	return rst;
}

/** 
* url: 特定功能的Url，如：/wifi/status 
 * callback: 回调函数 
 * requestType: The type of request to make ("POST" or "GET"), default is "GET". 
 * requestJson: 请求参数
 * urlHeadType: 为null则调用地址头采用Mifi接口的；否则: adUrlHead。
 */
function mifiRequest(url, callback, requestType, requestJson, urlHeadType, recallCount) {
	smartAjaxLog(url, requestJson, "request");
	if (recallCount == null)
		recallCount = 1;
	
	if (requestType == null)
		requestType = "GET";

	var headers;
	var contentType;
	if (requestType == "POST") {
		contentType = "application/json;charset=UTF-8";
	}

	var postData;
	if (requestJson != null) {
		postData = JSON.stringify(requestJson);
	}
	
	var aUrlHead = getUrlHeadAjax();
	if (urlHeadType == 1){
		aUrlHead = adUrlHead;
	} else if (urlHeadType == 2){
		aUrlHead = statUrlHead;
	}
	
	var timeCount = 1500;
	if (url.indexOf("/sms/get") == 0){
		timeCount = 3000;
	}

	if (callback) { // async call
		$.ajax({
			url : aUrlHead + url,
			async : true,
			type : requestType,
			data : postData,
			processData: true,
			contentType : contentType,
			timeout : timeCount,
			error : function() {
				if (recallCount > 0){
					recallCount--;
					mifiRequest(url, callback, requestType, requestJson, urlHeadType, recallCount);
				} else {
					errorProcess(url, urlHeadType);
				}
			},
			success : function(responseJson) {
				smartAjaxLog(url, responseJson, "response");
				
				if (judge(responseJson, url, urlHeadType))
					callback(responseJson);
			}
		});
	} else { // sync call
		var rst;
		$.ajax({
			url : aUrlHead + url,
			async : false,
			type : requestType,
			data : postData,
			contentType : contentType,
			timeout : 3000,
			error : function() {
				errorProcess(url, urlHeadType);
			},
			success : function(responseJson) {
				smartAjaxLog(url, responseJson, "response");
				if (judge(responseJson, url, urlHeadType))
					rst = responseJson;
			}
		});

		return rst;
	}
}

function judge(responseJson, url, urlHeadType){
	var rst = false;
	
	if (urlHeadType){
		rst = true;
	} else {
		if (responseJson && responseJson.errorCode == 0){
			rst = true;
		} else if (url == "/admin/login" || url.indexOf("/admin/changepassword") == 0){
			rst = true;
		} else {
			errorProcess(url, urlHeadType, responseJson && responseJson.errorCode);
		}
	}
	
	return rst;
}

function errorProcess(url, urlHeadType, validErrorCode){
	if (!urlHeadType){  //for test && false
		if (window.location.href.indexOf("index.html") >= 0){
			if (url == "/status"){
				showNotValidStatus();
			} else {
				signNotLogging();
			}
		} else if (window.location.href.indexOf("login.html") >= 0){
			//donothing
		} else {
			if (getMifiString("mifiState") != "0" && !validErrorCode)
				window.location = "index.html";
		}
	}
}

function getMifiString(c_name) {
	var rst = "";
	try{
		if (document.cookie.length > 0) {
			c_start = document.cookie.indexOf(c_name + "=");
			if (c_start != -1) {
				c_start = c_start + c_name.length + 1;
				c_end = document.cookie.indexOf(";", c_start);
				if (c_end == -1)
					c_end = document.cookie.length;
				rst = unescape(document.cookie.substring(c_start, c_end));
			}
		}
	} catch (e){
		rst = "";
	}
	
	return rst;
}

function setMifiString(c_name, value, expiredays) {
	var expiresPart = "";
	if (expiredays != null){
		var exdate = new Date()
		exdate.setTime(exdate.getTime() + expiredays * 24 * 60 * 60 * 1000);
		expiresPart = ";expires=" + exdate.toGMTString();
	}
	document.cookie = c_name + "=" + escape(value) + expiresPart;
}

function getApikey(){
	return getMifiString("apikey");
}

function json2Str(jsonData){
	return JSON.stringify(jsonData).replace(/,/g, ",\n");
}

function _gotoNewBrowserUrl(aUrl){
	return gotoUrl2(aUrl);
}

function smartAjaxLog(url, jsonObj, title){
	try {
		//if (url.indexOf("/mobiledata/sync") >= 0){
		mifiLog("Mifi ajax:[" + url + "]" + title + "  " + JSON.stringify(jsonObj));
		//}
	} catch (e) {
    }
}

function mifiLog(s){
	try {
		//console.log(s);
	} catch (e) {
    }
}
