var _filters = [];

$(function(){
	$("#clients").empty();
	
	mifiRequest("/wifi/status" + "?apikey=" + getApikey(), showWifiStatus);
	mifiRequest("/dhcp/status" + "?apikey=" + getApikey(), showDhcpStatus);
	filterList();
});

function filterList() {
	var responseJson = mifiRequest("/filter/list" + "?apikey=" + getApikey());
	if (responseJson.errorCode == 0 && responseJson.result.mode == "blacklist")
		_filters = responseJson.result.filters;
}

function showWifiStatus(rstJson){
	if (rstJson.errorCode != 0)
		return;
	
	var result = rstJson.result;
	
	$("#maxUserCount").html(result.maxUserCount);
}

function showDhcpStatus(rstJson){
	if (rstJson.errorCode != 0)
		return;
	
	var result = rstJson.result;
	var clients = result.clients;
	
	$("#connectUserCount").html(clients.length);
	for(var i = 0; i < clients.length; i++){
		var html = "<li>" +
						"<h4>" + clients[i].hostname + "</h4>" +
						"<p>IP:" + clients[i].ip + "<span>MAC:<span class='mac'>" + clients[i].macAddress + "</span></span></p>" +
						"<i class='i i-right '></i>" +
					"</li>";
		$("#clients").append(html);	
	}

////去除屏蔽功能	
//	$('#bd .r2 li i').click(function(){
//		$(this).toggleClass('i-wrong');
//		
//		$('.mark,.restart').show();
//		return false;
//	});
}

function preReboot(){
	var requestJson = {"mode": "blacklist"};
	$("#bd .r2 li i.i-wrong").each(function(){
		var macAddress = $(this).parent().find("span.mac").html();
		_filters.push({"hostname":"temp", "macAddress": macAddress});
	});
	requestJson.filters = _filters;
	
	mifiRequest("/filter/add" + "?apikey=" + getApikey(),null, "POST", requestJson);
}

