var QueryString;
$(function(){
	QueryString = function () {
		  // This function is anonymous, is executed immediately and 
		  // the return value is assigned to QueryString!
		  var query_string = {};
		  var query = window.location.search.substring(1);
		  var vars = query.split("&");
		  for (var i=0;i<vars.length;i++) {
		    var pair = vars[i].split("=");
		    	// If first entry with this name
		    if (typeof query_string[pair[0]] === "undefined") {
		      query_string[pair[0]] = pair[1];
		    	// If second entry with this name
		    } else if (typeof query_string[pair[0]] === "string") {
		      var arr = [ query_string[pair[0]], pair[1] ];
		      query_string[pair[0]] = arr;
		    	// If third or later entry with this name
		    } else {
		      query_string[pair[0]].push(pair[1]);
		    }
		  } 
		    return query_string;
		} ();
	
	$("#content").html(decodeURIComponent(escape(window.atob(QueryString.content))));
	$("#from").html(QueryString.from);
	$("#timestamp").html(decodeURI(QueryString.timestamp).substr(0,16).replace(/-/g, "."));
});

function sendMsg(){
	var val = $("#sendContent").val();
	if (val == null || val.length == 0){
		return;
	}
	
	var requestJson = {
		"to" : QueryString.from,
		"content" : utf8_to_b64($("#sendContent").val())
	};

	mifiRequest("/sms/send" + "?apikey=" + getApikey(),sendOk, "POST", requestJson);
}

function sendOk(rstJson){
	if (rstJson.errorCode != 0)
		return;
	
	$("ul").append("<li class='ar-fr'><p>" + $("#sendContent").val() + "</p></li>");
}