var ONEM = 1024 * 1024;
var _requestJson;

$(function(){
	var countDownVal=$('.countdown .time').text();
	var countDownTimer;
	/*点击自动校正弹出自动校正提示框*/
		$('#bd .r4 div.auto').click(function(){
			var requestmsg = getMifiString("requestmsg");
			
			if (requestmsg != null && requestmsg.length > 0){
				$('.mark').show();
				$('.countdown,.countdown .countdown-time').show();
				$('.countdown .time').text(countDownVal);
				
				receiveLastHisMsg();
				count_down(countDownVal);
			} else {
				window.location = "flowadjustsetting.html";
			}
		});
		
		// 校正倒计时
		function count_down(count) {
			if (_adjustOk){
				$('.mark,.countdown').hide();
				return;
			} else if (_receiveOk){
				
			} else if (_sendOk){
				mifiRequest("/sms/get" + "?apikey=" + getApikey() + "&mailbox=inbox&offset=0&count=1", processFlowAdjustMsg);
			}
			
			if (count > 0) {
				countDownTimer = setTimeout(function() {
					count--;
					$('.countdown .time').text(count);
					count_down(count);
				}, 1000);
			} else {
				$('.countdown').hide();
				$('#bd .r3 span').html("自动校正超时，请转手动校正");
				$('#bd .r3 span').addClass('on');
				clearTimeout(countDownTimer);
				$('.countdown').hide();
				$('.mark').hide();
			}
		}
		
		/*点击手动校正弹出手动校正提示框*/
		$('#bd .r4 div.hand').click(function(){
			$('.handadjust,.mark').show();
			
		})
		
		// 点击确定显示手动校正成功
		$('.handadjust input.confirm-btn').click(function(){
			var dataUsage = parseFloat($("#dataUsageAdjust").val());
			if (dataUsage <= ONEM){
				_requestJson.dataUsage = Math.round(dataUsage * ONEM);
				sync();
			} else {
				$("#handadjusthint").html("本月已使用流量,最大1T");
			}
		})
		
		// 点击取消，关闭提示框
		$('.handadjust input.cancel-btn').click(function(){
			$('.handadjust,.mark').hide();
		})
		
	/*点击mark,取消提示框*/
		$('.mark').click(function(){
			$('.handadjust,.autoadjust,.mark').hide();
		})
		
	/*点击倒计时的mark“显示短信获取超时”*/
		$('.countdown ').click(function(){
			$('.countdown .countdown-time').hide();
			$("#failHint").html("停止自动校正");
			$('.fail').show();
			clearTimeout(countDownTimer);
			$('.countdown').hide();
			setTimeout(function(){
					$('.fail,.mark').hide();
				},2000);
		});

	/*下拉选项栏*/
		// 显示下拉选项栏
		$('.autoadjust fieldset .select').click(function(){
		$(this).next('ul').show();

		});
		// 点击下拉选项栏，值赋
		$('.autoadjust fieldset>div ul li').click(function(){
			var val=$(this).text();
			$(this).parent().prev().find('span').text(val);
			$(this).parent().hide();
		});

		var date = new Date();
		var strReq = "/mobiledata/stat" + "?year=" + date.getFullYear() + "&month=" + (date.getMonth() + 1) + "&apikey=" + getApikey();
		mifiRequest(strReq, showMobiledataStat);
});

function testFlowAdjust(s){
	var rstJson;
	var sConv = s.toLowerCase() + "。";
	
	////数值之后必须有非汉字以避免获取4G
	var flagArr = ["已累计使用流量", "使用的上网数据流量有", "已使用数据流量", "使用的4G流量", "已使用"];
	for (var i = 0; i < flagArr.length; i++){
		var regexp = new RegExp(convertCHN(flagArr[i]) + "[\\d\\.]+[m|k|g]b*[^\\u4e00-\\u9fa5]", "g");
		var bestJson = testOneReg(sConv, regexp);
		
		if (bestJson){
			break;
		}
	}  //end of for
	
	var smartFlagArr = ["已累计使用", "累计使用", "已使用", "使用"];
	////标志和数值之间可以有任何汉字，数值之后必须有非汉字以避免获取4G
	if (!bestJson){
		for (var i = 0; i < smartFlagArr.length; i++){
			var regexp = new RegExp(convertCHN(smartFlagArr[i]) + "[\\u4e00-\\u9fa5]*[\\d\\.]+[m|k|g]b*[^\\u4e00-\\u9fa5]", "g");
			var bestJson = testOneReg(sConv, regexp);
			
			if (bestJson){
				break;
			}
		}
	}
	
	////标志和数值之间可以有任何汉字
	if (!bestJson){
		sConv = sConv.replace(/[34]g/g, "");
		for (var i = 0; i < smartFlagArr.length; i++){
			var regexp = new RegExp(convertCHN(smartFlagArr[i]) + "[\\u4e00-\\u9fa5]*[\\d\\.]+[m|k|g]", "g");
			var bestJson = testOneReg(sConv, regexp);
			
			if (bestJson){
				break;
			}
		}
	}
	
	if (bestJson){
		rstJson = {};
		rstJson.dataUsage = bestJson.d + "," + bestJson.u.toUpperCase();
		rstJson.result = 0;
	}
	
	return rstJson;
}

function convertCHN(regPart){
	return escape(regPart).replace(/%/g, "\\").toLowerCase();
}

function testOneReg(s, regexp){
	var n = s.match(regexp);
	
	var bestJson;
	var curJson;
	if (n && n.length > 0){
		for (var j = 0; j < n.length; j++){
			var arr = n[j].match(/[\d\.]+[m|k|g]/g);
			if (arr && arr.length >= 1){
			
				var flow = arr[arr.length - 1];
				if (flow != null){
					try{
						curJson = {};
						curJson.d = parseFloat(flow.match(/[\d\.]+/)[0]);
						curJson.u = flow.match(/[m|k|g]/)[0];
						
						if (bestJson){
							if (covertFLowDate(curJson.d, curJson.u) > covertFLowDate(bestJson.d, bestJson.u))
								bestJson = curJson;
						} else {
							bestJson = curJson;
						}
					} catch(err){
						
					}
				}
				
			}
		}  //end of for j
	}
	
	return bestJson;
}

//unit: K,M,G
//return in K
function covertFLowDate(data, unit){
	var rst = data;
	if (unit == "M")
		rst *= 1024;
	else if (unit == "G")
		rst *= 1024 * 1024;
	
	return rst;
}

function sync(){
	mifiRequest("/mobiledata/sync" + "?apikey=" + getApikey(),function (response){
		if (response.result != null && response.result.dataUsage != null){
			//校正时间
			var myDate = new Date();
			var sTime = (myDate.getMonth() + 1) + "月" + myDate.getDate() + "日<strong>" +
				formatTime(myDate.getHours()) + ":" + formatTime(myDate.getMinutes()) + "</strong>";
			$("#adjustTime").html(sTime);
			setMifiString("adjustTime", sTime);
			
			$("#dataUsage").val((response.result.dataUsage / ONEM).toFixed(2));
			
			$('#bd .r3 span').html("流量校正已成功");
			$('#bd .r3 span').addClass('on');
			$('.handadjust,.mark').hide();
			
			_adjustOk = true;
		}
	}, "POST", _requestJson);
};

var _lastHisMsgId = -1;
function receiveLastHisMsg(){
	mifiRequest("/sms/get" + "?apikey=" + getApikey() + "&mailbox=inbox&offset=0&count=1", function (rstJson){
		if (rstJson.errorCode != 0)
			return;
		
		var result = rstJson.result;
		var messages = result.messages;
		
		if (messages && messages.length > 0){
			var message = messages[0];
			_lastHisMsgId = message.id;
		}
		
		sendMsg();
	});
}

var _sendOk = false;
var _receiveOk = false;
var _adjustOk = false;
var _adjustSendTo;
var _sendTime;
var _messages;
function sendMsg(){
	_sendTime = new Date();
	_sendOk = false;
	_receiveOk = false;
	_adjustOk = false;
	
	var carriers = getMifiString("carriers");
	_adjustSendTo = carriers == "1" ? "10010" : "10086";
	var requestJson = {
		"to" : _adjustSendTo,
		"content" : window.btoa(getMifiString("requestmsg"))
	};

	mifiRequest("/sms/send" + "?apikey=" + getApikey(),sendOk, "POST", requestJson);
}

function sendOk(rstJson){
	_sendOk = true;
}

function processFlowAdjustMsg(rstJson){
	if (rstJson.errorCode != 0)
		return;
	
	var result = rstJson.result;
	_messages = result.messages;
	
	if (_messages.length > 0){
		var message = _messages[0];
		if (message.from.lastIndexOf(_adjustSendTo) >= 0){
			if (message.id != _lastHisMsgId) {
				_receiveOk = true;
				
				var msgInfo = {
				    "content": decodeURIComponent(escape(window.atob(_messages[0].content))),
				    "imei": getMifiString("imei"),
				    "from": _adjustSendTo,
				    "province": "未知",
				    "carriers": getMifiString("carriers"),
				    "timestamp": _messages[0].timestamp
				};
				
				var flowJson = testFlowAdjust(msgInfo.content);
				if (flowJson){
					flowAdjust(flowJson);
				} else {
					mifiRequest("/mifi/flowAdjust.json", flowAdjust,"POST", msgInfo, 1);
				}
			}
		}
	}
}

function flowAdjust(rstJson){
	if (rstJson.result == 0 && rstJson.dataUsage){
		var arr = rstJson.dataUsage.split(",");
		if (arr.length == 2){
			var usage = parseFloat(arr[0]);
			if ("M" == arr[1])
				_requestJson.dataUsage = Math.round(usage * ONEM);
			else if ("G" == arr[1])
				_requestJson.dataUsage = Math.round(usage * ONEM * 1024);
			else if ("K" == arr[1])
				_requestJson.dataUsage = Math.round(usage * 1024);
			
			sync();
		}
	}
}

function showMobiledataStat(rstJson){
	if (rstJson.errorCode != 0)
		return;
	
	var result = rstJson.result;
	_requestJson = {};
	_requestJson.dataUsage = result.dataUsage;
	
	$("#dataUsage").val((result.dataUsage / ONEM).toFixed(2));
	$("#adjustTime").html(getMifiString("adjustTime"));
}
