﻿
var myScroll,
	pullDownEl, pullDownOffset,
	pullUpEl, pullUpOffset,
	generatedCount = 0;

function pullDownAction () {
	setTimeout(function() {
		myScroll.refresh();	
	}, 2000);
}

function pullUpAction () {
	setTimeout(function() {
		myScroll.refresh();	
	}, 2000);
}

function loaded() {
	pullDownEl = document.getElementById('pullDown');
	if (pullDownEl)
		pullDownOffset = pullDownEl.offsetHeight;
	else
		pullDownOffset = 0;
		
	pullUpEl = document.getElementById('pullUp');	
	if (pullUpEl)
		pullUpOffset = pullUpEl.offsetHeight;
	else
		pullUpOffset = 0;
	
	myScroll = new iScroll('bd', {
		useTransition: true,
		topOffset: pullDownOffset,
		notRefreshOnLoad: typeof(signLogged) == "function",
		onRefresh: function () {
			if (pullDownEl && pullDownEl.className.match('loading')) {
				pullDownEl.className = '';
				pullDownEl.querySelector('.pullDownLabel').innerHTML = '下拉刷新...';
				
				if (window.location.href.indexOf("index.html") >= 0){
					window.location = "index.html";
				}
			} else if (pullUpEl && pullUpEl.className.match('loading')) {
				pullUpEl.className = '';
				pullUpEl.querySelector('.pullUpLabel').innerHTML = '上拉获取更多...';
			}
		},
		onScrollMove: function () {
			if (pullDownEl && this.y > 5 && !pullDownEl.className.match('flip')) {
				pullDownEl.className = 'flip';
				pullDownEl.querySelector('.pullDownLabel').innerHTML = "松开刷新..." + "<br>最后刷新：" + getMifiString("refreshTime");
				this.minScrollY = 0;
			} else if (pullDownEl && this.y < 5 && pullDownEl.className.match('flip')) {
				pullDownEl.className = '';
				pullDownEl.querySelector('.pullDownLabel').innerHTML = '下拉刷新...';
				this.minScrollY = -pullDownOffset;
			} else if (pullUpEl && this.y < (this.maxScrollY - 5) && !pullUpEl.className.match('flip')) {
				pullUpEl.className = 'flip';
				pullUpEl.querySelector('.pullUpLabel').innerHTML = '松开刷新...';
				this.maxScrollY = this.maxScrollY;
			} else if (pullUpEl && this.y > (this.maxScrollY + 5) && pullUpEl.className.match('flip')) {
				pullUpEl.className = '';
				pullUpEl.querySelector('.pullUpLabel').innerHTML = '上拉获取更多...';
				this.maxScrollY = pullUpOffset;
			}
		},
		onScrollEnd: function () {
			if (pullDownEl && pullDownEl.className.match('flip')) {
				pullDownEl.className = 'loading';
				pullDownEl.querySelector('.pullDownLabel').innerHTML = '加载中...';
				//$("#refresh")[0].className = 'refresh-circle';
				$("#refresh-ico")[0].src = 'images/refresh-circle.png';
				$("#refresh-ico")[0].className = 'refresh-circle';
				
				pullDownAction();	// Execute custom function (ajax call?)
			} else if (pullUpEl && pullUpEl.className.match('flip')) {
				pullUpEl.className = 'loading';
				pullUpEl.querySelector('.pullUpLabel').innerHTML = '加载中...';				
				pullUpAction();	// Execute custom function (ajax call?)
			}
		}
	});
	
	setTimeout(function () { document.getElementById('bd').style.left = '0'; }, 800);
}



document.addEventListener('touchmove', function (e) { e.preventDefault(); }, false);

document.addEventListener('DOMContentLoaded', function () { setTimeout(loaded, 200); }, false);
