var _waked = false;
var _loginFailInterval;
var _hintInterval;

$(function(){
	init();
	$('.mark').show();
	$('.loginbox').show();
	
	wakedPage();
});

function getWaked(){
	return _waked;
}

function init(){
	var userName = getMifiString("username");
	if (userName && (userName == "" || userName.toLowerCase() == "null" || userName.toLowerCase() == "(null)" || userName.toLowerCase() == "undefined")){
		userName = null;
	}
	$("#username").val(userName || "admin");
	
	if (getMifiString("savepwd") == "TRUE"){
		$("#password").val(getMifiString("password"));
		$("#savepassword").prop("checked", true);
	} else {
		$("#password").val("");
		$("#savepassword").prop("checked", false);
	}
	
	$('.mark').click(function(){
		if (typeof getWaked === "function" && !getWaked()){
			return;
		}
		
		if (_hintLoginFail && $(".hintdialog").is(":visible")){
			closeLoginFailHint(".hintdialog");
		}
	});	
}

function login(){
	if (!getWaked()){
		return;
	}
		
	var requestJson = {
		"username": $("#username").val(),
		"password": $("#password").val()
	};
	
	var rstJson = mifiRequest("/admin/login", null, "POST", requestJson);
	if (rstJson == null || rstJson.errorCode != 0){
		showLoginFailHint(".hintdialog", "用户名与密码不匹配！<br>请重试");
		
		goSleep();
	} else if (rstJson.errorCode == 0){
		var apikey = rstJson.result.apikey;
		setMifiString("apikey", apikey);
		
		setMifiString("username", $("#username").val(), 30);
		if ($("#savepassword").prop("checked")){
			setMifiString("savepwd", "TRUE", 30);
			var password = $("#password").val();
			setMifiString("password", password, 30);
		} else {
			setMifiString("savepwd", "FALSE", 30);
		}
		
		setMifiString("mifiState", "2");
		exit();
	}
}

function cancelLogin(){
	if (!getWaked()){
		return;
	}
	
	exit();
}

function exit(){
	var prev = getMifiString("prevLogin");
	window.location = prev;
}

var _hintLoginFail = false;
function showHint(dialogId, sHint){
	if (sHint && sHint != "")
		$(dialogId).find("p").html(sHint);
		
	$(dialogId).show();
	setTimeout("closeHint('" + dialogId + "');", 2000);
}

function closeHint(dialogId){
	exit();
}

function showLoginFailHint(dialogId, sHint){
	_hintLoginFail = true;
	$('.loginbox').hide();
	
	if (sHint && sHint != "")
		$(dialogId).find("p").html(sHint);
		
	$(dialogId).show();
	_loginFailInterval = setTimeout("closeLoginFailHint('" + dialogId + "');", 2000);
}

function closeLoginFailHint(dialogId){
	_hintLoginFail = false;
	clearInterval(_loginFailInterval);
	$(dialogId).hide();
	$('.loginbox').show();
}
