var _delId;
var _box = "inbox";
var COUNT_PER_PAGE = 8;
var _title;

$(function(){
	_box = getMifiString("messageBox");
	_title = "MIFI短信--"
	if ("inbox" == _box)
		_title += "收件箱";
	else if ("outbox" == _box)
		_title += "发件箱";
	else if ("sentbox" == _box)
		_title += "已发送";
	
	$("h1").html(_title);
	
	/*点击取消或蒙版隐藏提示框*/
	$('.delbox .grey-btn,.mark').click(function(){
		$('.mark,.delbox').hide();
	});
	
	/*点击提示框中的删除，删除记录*/
	$('.delbox .green-btn').click(function(){
		//delli.remove();  //服务端未实现
		var requestJson = {};
		requestJson.mailbox = _box;
		requestJson.id = _messages[_delId].id;
		mifiRequest("/sms/remove" + "?apikey=" + getApikey(), delMsgOK, "POST", requestJson);
	});
	
	//为了解决界面刷新的问题
	$("#ulMessage").append("<li></li>");
	
	mifiRequest("/sms/get" + "?apikey=" + getApikey() + "&mailbox=" + _box + "&offset=0&count=" + COUNT_PER_PAGE, showSmsGetFirst);
});

function delMsgOK(rstJson){
	$('.mark,.delbox').hide();
	if (rstJson.errorCode == 0){
		$("#ulMessage li[data-id='" + _delId + "']").remove();
		$("h1").html(_title + "(" + $("#ulMessage li").length + ")");
	}
}

function moreMsg(){
	var offset = $("#ulMessage li").length;
	mifiRequest("/sms/get" + "?apikey=" + getApikey() + "&mailbox=" + _box + "&offset=" + offset + "&count=" + COUNT_PER_PAGE, showSmsGetMore);
}

var _messages = [];
function showSmsGetFirst(rstJson, clear){
	showSmsGet(rstJson, true);
}

function showSmsGetMore(rstJson, clear){
	showSmsGet(rstJson, false);
}

function showSmsGet(rstJson, clear){
	if (clear){
		$("#ulMessage").empty();
		_messages = [];
	}
	
	if (rstJson.errorCode != 0)
		return;
	
	var result = rstJson.result;
	var messages = result.messages;
	
	var haveMore = messages != null && messages.length >= COUNT_PER_PAGE;
	$("#moreMsg").remove();
	
	var msgCount = _messages.length;
	for (var i = 0; i < messages.length; i++){
		var message = messages[i];
		var gIndex = msgCount + i;
		_messages[gIndex] = message;
		var sHtml = "<li data-id='" + gIndex + "'>" +
						"<a href='#'>" +
							"<div class='user'><img src='images/user.png'></div>" +
							"<div class='message' onclick='showDetail(" + gIndex + ")'>" +
								"<div>" +
									"<h3>" + message.from + "</h3>" +
									"<dl style='position: absolute;top: 0.5em;right: 2.5em;'><h3 style='color: black;font-size: 0.66em;'>" + message.timestamp.substr(0,16).replace(/-/g, ".") + "</h3></dl>" +
								"</div>" +
								"<p>" + decodeURIComponent(escape(window.atob(message.content))) + "</p>" +					
							"</div>" +
							"<i class='i-delete' onclick='delMsg(" + gIndex + ")'></i>" +			
						"</a>" +
					"</li>";
		$("#ulMessage").append(sHtml);
	}
	
	if (haveMore)
		$("#ulMessage").append("<div id='moreMsg' onclick='moreMsg();'>更多短信</div>");
	$("h1").html(_title + "(" + $("#ulMessage li").length + ")");
	//var s = "尊敬的客户，截至3月1日16时11分，本月您已使用的流量情况如下：数据流量共30M，已使用759K，还剩余29.26M。已使用的流量资源情况可能小于您的实际使用量，敬请谅解！具体流量使用详见移动官方网站（www.sh.10086.cn ）。回复666可订购流量加油包，获得更多优惠流量！中国移动。";
	//dataUsageMatch(s, /\u6570\u636e\u6d41\u91cf\u5171\w*\uff0c/);
	//dataUsageMatch(s, /\u5df2\u4f7f\u7528\w*\uff0c/);
}

function dataUsageMatch(msg, regExp){
    var arr = msg.match(regExp);
    var unit = arr[0].match(/[A-Za-z]+/)[0];
    var value = arr[0].match(/\d+/)[0];
    alert(value + "," + unit);
}

function delMsg(msgId){
	_delId = msgId;
	$('.mark,.delbox').show();
	return false;
}

function showDetail(msgIndex){
	window.location = "detailmessage.html?content=" + _messages[msgIndex].content + "&from=" + _messages[msgIndex].from + "&timestamp=" + encodeURI(_messages[msgIndex].timestamp);
}