$(function() {
	//点击蒙版取消弹出窗口
	$('.mark').click(function(){
		$(".hintdialog").hide();
		
		if (!$(".editpassword").is(":visible")){
			$('.mark').hide();
		}
	});
	
	/* 恢复出厂设置弹框 */
	$('#resetsetting').click(function() {
		$('.mark,.resetsetting').show();
	});
});

function resetCancel() {
	$('.mark,.resetsetting').hide();
}

function resetOK() {
	mifiRequest("/admin/factoryreset" + "?apikey=" + getApikey(), function(rstJson) {
		$('.mark,.resetsetting').hide();
	}, "POST", {});
}

/* 修改密码弹框 */
function showChangePwd() {
	$('.mark,.editpassword').show();
};

// 点击蒙版或取消，隐藏弹框
function changePwdCancel() {
	$('.mark,.editpassword').hide();
};

// 点击确认，隐藏弹框并把新密码赋值
function changePwdOK() {
	var newval1 = $('.editpassword input[type="password"]:eq(1)').val();
	var newval2 = $('.editpassword input[type="password"]:eq(2)').val();
	// 判断密码是否相等
	if (newval1 === newval2) {
		if (!testReg(newval1, /^\S*$/) || !testReg(newval1, /^[x00-xff]*$/)){
			showHint(".hintdialog", "密码值含有无效字符");
		} else if (newval1 != '' && newval1 != '') {
			var requestJson = {
				"oldpassword" : $('.editpassword input[type="password"]:eq(0)').val(),
				"newpassword" : newval1
			};

			mifiRequest("/admin/changepassword" + "?apikey=" + getApikey(),
					changePassword, "POST", requestJson);
		} else {
			showHint(".hintdialog", "密码不能为空！");
		}
	} else {
		showHint(".hintdialog", "两次输入新密码不一致！");
	}
};

function changePassword(rstJson) {
	if (rstJson.errorCode == 0){
		$('.mark,.editpassword').hide();
		showHint(".hintdialog", "密码变更成功");
	} else if (rstJson.errorCode == 20103){
		showHint(".hintdialog", "原密码错误！");
	} else {
		showHint(".hintdialog", "密码变更失败！");
	}
	
}

function testReg(s, re){
	var rst = false;
	if(re.test(s)){  
	    rst = true;
	}
	
	return rst;
}

//////////////////////////////////////////////PUBLIC/////////////////////////////////////////////
function showHint(dialogId, sHint){
	if (sHint && sHint != "")
		$(dialogId).find("p").html(sHint);
		
	$('.mark').show();
	$(dialogId).show();
	setTimeout("closeHint('" + dialogId + "');", 2000);
}

function closeHint(dialogId){
	$(dialogId).hide();
	
	if (!$(".editpassword").is(":visible")){
		$('.mark').hide();
	}
}
