var nativeStr = "";

function callNative(url) {
	nativeStr = "";
    var iFrame;
    iFrame = document.createElement("iframe");
    iFrame.setAttribute("src", url);
    iFrame.setAttribute("style", "display:none;");
    iFrame.setAttribute("height", "0px");
    iFrame.setAttribute("width", "0px");
    iFrame.setAttribute("frameborder", "0");
    document.body.appendChild(iFrame);
    iFrame.parentNode.removeChild(iFrame);
    iFrame = null;
    return nativeStr;
}

function returnResult(ntStr)
{
	nativeStr = ntStr;
}

var deviceType = "";
(function () {
	if (/(iPhone|iPad|iPod|iOS)/i.test(navigator.userAgent)) {
        deviceType = "iOS";
		function MifiHttp () {
	
		}

		MifiHttp.prototype = {
			setString: function(key, value) {
				callNative("MifiApi://setString?"+key+"="+value);
			},
			getString: function(key, defaultValue) {
				var ret = callNative("MifiApi://getString?key="+key);
				if (ret == "" && typeof defaultValue != "undefined")
					return defaultValue;
				return nativeStr;
			},
			browser: function(url) {
				callNative("MifiApi://browser?url="+url);
			},
			httpGetRequest: function(url) {
				return callNative("MifiApi://getrequest?url="+url);
			},
			log: function(msg){
				callNative("MifiApi://log?msg="+msg);
			},
			scanBarcode: function() {
				callNative("MifiApi://scanbarcode");
			}
		}

		window.MifiHttp = new MifiHttp();
	} else if (/(Android)/i.test(navigator.userAgent)) {
        deviceType = "android"
	} else {
    	deviceType = "browser";
	};
})();
