var _ulShowing = false;
var _waked = true;

function getWaked(){
	return _waked;
}

$(function(){
	/*下拉选项栏*/
	// 显示下拉选项栏
	$('.flowsetting i.fr').click(function(){
		_ulShowing = true;
		if ($(this).parent().next('ul').is(":visible"))
			$(this).parent().next('ul').hide();
		else
			$(this).parent().next('ul').show();
	});
	
	$("div#bd").click(function(){
		if (_ulShowing){
			_ulShowing = false;
		} else if ($(".flowsetting ul").is(":visible")){
			$(".flowsetting ul").hide();
		}
	});
	
	// 点击下拉选项栏，值赋
	$('.flowsetting ul li').click(function(){
		var val=$(this).text();
		
		$(this).parent().hide();
		
		if (val == "自定义"){
			$("#dataLimit").prop("disabled", false);
			$("#dataLimit").focus();
		} else {
			$("#dataLimit").prop("disabled", true);
			$("#dataLimit").val(val);
		}
		
		//关闭已保存提示
		$('.flowsetting+p').hide();
	});
	
	$("#dataLimit").bind("change paste keyup", function() {
		$('.flowsetting+p').hide();
	});
	
	$("#dataLimit").blur(function(){
		$("#dataLimit").prop("disabled", true);
	});
		
	/*点击保存*/	
	$('.r1 .flowsave div.green-btn').click(function(){
		var dataLimit = 0;
		var sLimit = $("#dataLimit").val().toUpperCase();
		
		if (!testPackageVal(sLimit)){
			$("#hint").html("无效的套餐值");
			$('.flowsetting+p').show();
			return;
		} 
		
		try {
			if (sLimit.indexOf("G") > 0)
				dataLimit = parseFloat(sLimit.replace(/G/, "")) * 1024;
			else if (sLimit.indexOf("M") > 0)
				dataLimit = parseFloat(sLimit.replace(/M/, ""));
		} catch (err) {
			
		}

		if (dataLimit > 0){
			_requestJson.dataLimit = Math.round(dataLimit);
		}
		
		mifiRequest("/mobiledata/sync" + "?apikey=" + getApikey(),function (rstJson){
			if (rstJson.errorCode == 0){
				//提示设置已保存
				$("#hint").html("设置已保存");
				$('.flowsetting+p').show();
			}
		}, "POST", _requestJson);
	});
	
	var date = new Date();
	mifiRequest("/mobiledata/stat" + "?year=" + date.getFullYear() + "&month=" + (date.getMonth() + 1) + "&apikey=" + getApikey(), showMobiledataStat);
	
	initAd();
});

function testPackageVal(packageVal){
	var rst = false;
	var re =  /^[0-9\.]*[g|G|m|M]$/;
	if(re.test(packageVal)){  
	    rst = true;  
	}
	
	return rst;
}

function showMobiledataStat(rstJson){
	if (rstJson.errorCode != 0)
		return;
	
	var result = rstJson.result;
	_requestJson = {};
	_requestJson.dataLimit = result.dataLimit;
	
	var sLimit = "自定义";
	var limitOfG = result.dataLimit / 1024;
	if ($.inArray(limitOfG, [1,2,5,10]) >= 0){
		sLimit = (limitOfG) + "G";
		$("#dataLimit").prop("disabled", true);
	} else {
		if (limitOfG > 1)
			sLimit = limitOfG.toFixed(2) + "G";
		else
			sLimit = result.dataLimit.toFixed(2) + "M";
		
		$("#dataLimit").prop("disabled", false);
	}
	
	$("#dataLimit").val(sLimit);
	
	//为了解决界面刷新的问题
	$("#tempChk").prop("checked", true);
	$("#tempChk").hide();
}

function initAd(){
	if (!getSkipAd()){
		mifiRequest("/ad/206/detail.json", showAd, null, null, 1);
	}
}

function showAd(rstJson){
	if (rstJson && rstJson.length > 0){
		var adItem = rstJson[0];
		$(".ad").find("img:first").attr("src", adItem.content);
		$(".ad").find("img:first").attr("onclick", "gotoNewBrowserUrl('" + adItem.url+  "')");
	}
}
