var _waked = false;

$(function(){
	var date = new Date();
	var strReq = "/mobiledata/stat" + "?year=" + date.getFullYear() + "&month=" + (date.getMonth() + 1) + "&apikey=" + getApikey();
	mifiRequest(strReq, showMobiledataStat);
	
	wakedPage();
});

function getWaked(){
	return _waked;
}

function showMobiledataStat(rstJson){
	if (rstJson.errorCode != 0)
		return;
	
	var result = rstJson.result;
	
	var sLimit = "自定义";
	var limitOfG = result.dataLimit / 1024;
	if ($.inArray(result.dataLimit / 1024, [1,2,5,10]) >= 0){
		sLimit = (result.dataLimit / 1024) + "G";
	} else {
		if (limitOfG > 1)
			sLimit = limitOfG.toFixed(2) + "G";
		else
			sLimit = result.dataLimit.toFixed(2) + "M";
	}
	
	$("#dataLimit").text(sLimit);
	
	//showChart(result.history);
}

function showChart(history){
	var d1 = [];
	var sum = 0;
    for (var i = 0; i < history.length; i++){
    	sum += history[i] / 1024;
        d1.push([i + 1, sum]);
    }

    var options = {
    	    series: {
    	        lines: { show: true },
    	        points: { show: true }
    	    }
    	};
    $.plot($(".tab"), [d1], options);
}
