var _waked = false;

$(function(){
	setMifiString("curLocation", "wifi.html");
	var state = getMifiString("mifiState");
	if (state == "0" || state == "1"){
		if (state == "0"){
			$("div.r2 ul li").each(function(index) {
				if (index > 0)
					setNotValidColor($(this));
			});
		}
		
		$("#ssid").html("N/A");
		$("#broadcast").html("N/A");
		$("#mode").html("N/A");
		$("#runtime").html("N/A");
		$("#security").html("N/A");
	} else {
		mifiRequest("/wifi/status" + "?apikey=" + getApikey(), showWifiStatus);
		mifiRequest("/status",showStatus);
	}
	
	wakedPage();
});

function getWaked(){
	return _waked;
}

function readBarcode(){
	if (!_waked)
		return;
	
	goSleep();
	window.MifiHttp.scanBarcode();
}

function showWifiStatus(rstJson){
	if (rstJson.errorCode != 0)
		return;
	
	var result = rstJson.result;
	
	$("#ssid").html(result.ssid);
	$("#mode").html(wifiMode[result.mode + ""]);
	$("#security").html(wifiSecurityModeAll[result.security]);
}

function showStatus(rstJson){
	if (rstJson == null || rstJson.errorCode != 0){
		return;
	} 
	
	var result = rstJson.result;
	
	$("#broadcast").html(result.connectionStatus == 1 ? "连接" : "断开");
	
	var hour = Math.floor(result.powerOnTime / 3600);
	var minute = Math.floor((result.powerOnTime % 3600) / 60);
	$("#runtime").html(hour + "小时" + minute + "分");
}


