$(function() {
	mifiRequest("/status" + "?apikey=" + getApikey(), showStatus);
	mifiRequest("/dhcp/status" + "?apikey=" + getApikey(), showDhcpStatus);
});

function showStatus(rstJson) {
	if (rstJson.errorCode != 0)
		return;

	var result = rstJson.result;

	$("#softwareVersion").html(result.softwareVersion);
	$("#hardwareVersion").html(result.hardwareVersion);
	$("#imei").html(result.imei);
	$("#sn").html(result.sn);
	$("#macAddress").html(result.macAddress);
	$("#gatewayIp").html(getMifiString("gatewayIp"));
}

function showDhcpStatus(rstJson) {
	if (rstJson.errorCode != 0)
		return;

	var result = rstJson.result;

	$("#ip").html(result.ip);
	$("#subnetMask").html(result.subnetMask);
	$("#dns").html(result.dns);

}